Subject: Re: [CDNi] Comments on draft-caulfield-cdni-rate-pacing-01.txt

From: "Francois Le Faucheur (flefauch)" <[email-masked]>
Date: Mon, 3 Mar 2014 11:24:51 +0000

Hi Matt,

One more comment regarding section 4.1:
“

               +----------------+---------------+---------+
               | Algorithm Name | Specification | Version |
               +----------------+---------------+---------+
               | token-bucket   | RFCthis       | 1       |
               +----------------+---------------+---------+

"
I am not sure we want to have a full notion of “Version” inside the Registry (for example you’d have to define a full notion of version handling).
Instead I woudl suggest you simply have an algorithm name of “token-bucket/v1”. And if someone later defines a “token-bucket/v2” it is simply considered as another (unrelated) algorithm.

Francois

On 17 Feb 2014, at 17:50, Matt Caulfield (mcaulfie) <[email-masked]<mailto:[email-masked]>> wrote:

Thank you for the comments, Francois.

I agree with your feedback below and will plan to incorporate it in the next revision.

Regards,
Matt

-----Original Message-----
From: Francois Le Faucheur (flefauch)
Sent: Monday, February 17, 2014 11:47 AM
To: Matt Caulfield (mcaulfie)
Cc: [email-masked]<mailto:[email-masked]>
Subject: Comments on draft-caulfield-cdni-rate-pacing-01.txt

Hi Matt,

(With my individual contributor's hat on)

Comments below.

HTH

Francois

*** section 2.1:
"
A CDN MAY advertise the "RatePacing" capability in the FCI if it
  implements this specification and at least one rate pacing algorithm
  registered in the Rate Pacing algorithms registry.
"
This suggests that we can end up in a situation where CDN1 advertises only "token-bucket/v1" and CDN2 advertises only "rate-pacing-algorithm-bladibla".
Should we not promote a situation where any CDN that supports rate-pacing supports at least one common rate-pacing algorithm (eg "token-bucket/v1")?
I think this would make it a lot easier for an uCDN to define and market a consistent service to a CSP.

*** section 2.2.1:
"
For example, "token-bucket./v1"
"
should this read "token-bucket/v1" (without a dot)?

*** section 2.3:
What you are discussing here about dCDN selection based on "required" rate-pacing is actually a generic concept (but simply applied here to rate-pacing).
THis needs to be aligned to the discussions around FCI Manadatory/Optional capabilities + cdni-metadata.
In any case, I woudl suggest that you tweak your description to make it clear that what you are describing is not specific to rate-pacing, but is just describing how a generic concept applie sto rate-pacing.

*** section 2.4
"
Note that existing fields defined by [I-D.ietf-cdni-logging] include
  the bytes delivered and the time taken to service a request.
  However, the time taken includes the acquisition latency which is not
  relevant to rate pacing.
"
Given that the content items on which rate pacing is applied would be fairly large, I expect that the acquisition time would be typically negligible (e.g. within a similar error margin as the difference between an "average rate" and the tocken bucket rate).
But given this is an optional parameter, I don't have a problem in defining it.

*** section 2.4:
OLD:
"
The "sc-rate" field indicates the rate in bytes per
  second as a decimal number.
"
NEW:
"
A new "sc-rate" CDNI Logging Field is defined to indicate the rate in bytes per
  second as a decimal number.
"

*** section 2.4:
OLD:
"
Note that existing fields defined by [I-D.ietf-cdni-logging] include
  the bytes delivered and the time taken to service a request.
"
NEW:
"
Note that existing fields defined by [I-D.ietf-cdni-logging] include
  the bytes delivered and the time taken to service a request, which could be used to estimate the delivery rate.
"

*** section 3:
"3.  Rate Pacing Algorithm"
Since this document specifies one particular algorithm, and since its parameters are specified in this section, I'd suggest changing title to something like:
"3. Tocken Bucket Rate Pacing Algorithm and Parameters".

*** section 3:
The first paragraph is a litlle confusing because "Tocken Bucket" sometimes refers to the generic mechanisms and sometimes to how it is applied to CDNI.
I would recommend you distinguish the two:
* the generic tolken bucket concept [RFC1363]
* introduce a notion of "CDNI Tocken Bucket RAte Pacing"
Then you can explian that :
* this document specifies the "CDNI Tocken Bucket Rate Pacing"
* it is based on the generic token bucket, but applied in a CDNI context (ie by Surrogate when transmitting bytes of a response to a content
* clarify which bytes are to be accounted for in the bucket (eg L1? L2? IP? Transport? HTTP status response, HTTP headers,..)

*** section 3:
OLD:
"
If a RatePacing metadata object's "algo" value is "token-bucket/v1"
  then the metadata object's "params" is an object of type
  TokenBucketParams, described below.
"
NEW:
"
If a RatePacing metadata object's "algo" value is "token-bucket/v1"
  then the metadata object's "params" MUST be an object of type
  TokenBucketParams, described below.
"

*** Section 4.1:
"
New rate pacing algorithm registrations SHOULD specify RatePacing
  parameter objects as shown in Section 3.1 and SHOULD describe the
  algorithm for rate pacing.
"
Why is this SHOULD and not MUST?

typos:

"[I-D.ietf-cdni-footprint-capabilities-semantics]defines" -> "[I-D.ietf-cdni-footprint-capabilities-semantics] defines"

"[I-D.ietf-cdni-footprint-capabilities-semantics]states" -> "[I-D.ietf-cdni-footprint-capabilities-semantics] states"

"IANA is requested to create new registry" -> "IANA is requested to create a new registry"

On 13 Feb 2014, at 19:34, [email-masked]<mailto:[email-masked]> wrote:

A New Internet-Draft is available from the on-line Internet-Drafts directories.

      Title           : CDNI Rate Pacing
      Author          : Matt Caulfield
Filename        : draft-caulfield-cdni-rate-pacing-01.txt
Pages           : 8
Date            : 2014-02-13

Abstract:
 Rate pacing is a class of network traffic shaping which limits the
 transmission rate of data over a network.  This document defines CDNI
 extensions for downstream CDNs to support rate pacing on behalf of
 upstream CDNs.

The IETF datatracker status page for this draft is:
https://datatracker.ietf.org/doc/draft-caulfield-cdni-rate-pacing/

There's also a htmlized version available at:
http://tools.ietf.org/html/draft-caulfield-cdni-rate-pacing-01

A diff from the previous version is available at:
http://www.ietf.org/rfcdiff?url2=draft-caulfield-cdni-rate-pacing-01

Please note that it may take a couple of minutes from the time of
submission until the htmlized version and diff are available at tools.ietf.org.

Internet-Drafts are also available by anonymous FTP at:
ftp://ftp.ietf.org/internet-drafts/

_______________________________________________
I-D-Announce mailing list
[email-masked]
https://www.ietf.org/mailman/listinfo/i-d-announce
Internet-Draft directories: http://www.ietf.org/shadow.html or
ftp://ftp.ietf.org/ietf/1shadow-sites.txt

---

From: "Matt Caulfield (mcaulfie)" <[email-masked]>
Date: Mon, 3 Mar 2014 14:23:07 +0000

Hi Francois,

Yes, I tend to agree. A flat name space (with no version) would be easier to manage. I will incorporate this (and your other comments) in my next revision.

Thank you,
Matt

From: Francois Le Faucheur (flefauch)
Sent: Monday, March 03, 2014 6:25 AM
To: Matt Caulfield (mcaulfie)
Cc: Francois Le Faucheur (flefauch); [email-masked]
Subject: Re: Comments on draft-caulfield-cdni-rate-pacing-01.txt

Hi Matt,

"
I am not sure we want to have a full notion of "Version" inside the Registry (for example you'd have to define a full notion of version handling).
Instead I woudl suggest you simply have an algorithm name of "token-bucket/v1". And if someone later defines a "token-bucket/v2" it is simply considered as another (unrelated) algorithm.

Francois

Regards,
Matt

-----Original Message-----
From: Francois Le Faucheur (flefauch)
Sent: Monday, February 17, 2014 11:47 AM
To: Matt Caulfield (mcaulfie)
Cc: [email-masked]<mailto:[email-masked]>
Subject: Comments on draft-caulfield-cdni-rate-pacing-01.txt

Hi Matt,

Comments below.

HTH

Francois

*** section 2.1:
"

*** section 2.2.1:
"

*** section 2.3:

*** section 2.4
"

*** section 2.4:
OLD:
"

*** section 2.4:
OLD:
"

*** section 3:

*** section 3:

*** section 3:
OLD:
"

*** Section 4.1:
"

typos:

      Title           : CDNI Rate Pacing
      Author          : Matt Caulfield

Abstract:

[email-masked]<mailto:[email-masked]>